# Wordpress

[![Build Status](https://build.coopcloud.tech/api/badges/coop-cloud/wordpress/status.svg)](https://build.coopcloud.tech/coop-cloud/wordpress)

Coöp Cloud + [Wordpress](https://wordpress.org) = 🥳

<!-- metadata -->

* **Category**: Apps
* **Status**: 3, stable
* **Image**: [`wordpress`](https://hub.docker.com/_/wordpress), 4, upstream
* **Healthcheck**: Yes
* **Backups**: Yes
* **Email**: 3
* **Tests**: 2
* **SSO**: No

<!-- endmetadata -->

## Basic usage

1. Set up Docker Swarm and [`abra`][abra]
2. Deploy [`coop-cloud/traefik`][cc-traefik]
3. `abra app new wordpress --secrets` (optionally with `--pass` if you'd like
   to save secrets in `pass`)
4. `abra app config YOURAPPDOMAIN` - be sure to change `$DOMAIN` to something that resolves to
   your Docker swarm box
5. `abra app deploy YOURAPPDOMAIN`
6. Open the configured domain in your browser to finish set-up
7. `abra app run YOURAPPDOMAIN app chown www-data:www-data /var/www/html/wp-content` to fix
   file permissions (see #3)

## Running WP-CLI

`abra app cmd YOURAPPDOMAIN app wp -- core check-update --major`

## Network (Multi-site)

_(Only tested using subdomains)_

1. Set up as above
2. `abra app config YOURAPPDOMAIN`, and uncomment the first `# Multisite` section
3. `abra app deploy YOURAPPDOMAIN`
4. Log into the Wordpress admin dashboard, go to Tools » Network Setup
5. Don't worry about the suggested file changes
6. `abra app config YOURAPPDOMAIN` again - comment out the first `# Multisite`
   section in `.envrc`, uncomment the `# Multisite phase 2` section, and add
   your multisite subdomain(s) to `EXTRA_DOMAINS` (beware the weird syntax..)
7. `abra app deploy YOURAPPDOMAIN`

## Installing a custom theme

`abra app cp YOURAPPDOMAIN ~/path/to/local/theme wordpress:/var/www/html/wp-content/themes/`

## Email

There is a local or remote SMTP relay configuration available.

* **local**: `COMPOSE_FILE=compose.yml:compose.mailrelay.yml`
* **remote**: `COMPOSE_FILE=compose.yml:compose.mailrelay.yml:compose.smtp.yml`

Below are the instructions for the local relay.

1. Deploy [`postfix-relay`][cc-postfix-relay]
2. `abra app config YOURAPPDOMAIN`, and uncomment the email lines; change
   `MAIL_FROM` to make sure the domain is the same as `postfix-relay`'s
   `$DOMAIN` or in its `$EXTRA_SENDER_DOMAINS`
3. `abra app deploy YOURAPPDOMAIN`

[abra]: https://git.autonomic.zone/autonomic-cooperative/abra
[cc-traefik]: https://git.autonomic.zone/coop-cloud/traefik
[cc-postfix-relay]: https://git.autonomic.zone/coop-cloud/traefik
